@use 'sass:map';
@use '@angular/material'as mat;

@use '../palette';

// component mixins
@use 'header-theme'as header;
@use 'search-filter-theme'as toolbar;
@use 'standard-hover'as hover;
@use 'password-hint-color'as pass-hint;
@use 'error-component-color'as error-comp;


@mixin set-colors($theme) {
  // config
  $config: mat.get-color-config($theme);
  // palette colors
  $primary-palette: map.get($config, 'primary');
  $accent-palette: map.get($config, 'accent');
  $warn-palette: map.get($config, 'warn');

  // palette background
  $foreground-palette: map.get($config, foreground);
  $background-palette: map.get($config, background);

  // @debug "$background-palette: #{$background-palette}";

  // is dark
  $is-dark-theme: map.get($config, 'is-dark');

  // primary colors -  read the hues from the primary color palette.
  $primary-color: mat.get-color-from-palette($primary-palette);
  $primary-color-50: mat.get-color-from-palette($primary-palette, 50);
  $primary-color-100: mat.get-color-from-palette($primary-palette, 100);
  $primary-color-400: mat.get-color-from-palette($primary-palette, 400);
  $primary-color-500: mat.get-color-from-palette($primary-palette, 500);

  $warn-color: mat.get-color-from-palette($warn-palette);
  $warn-color-100: mat.get-color-from-palette($warn-palette, 100);
  $warn-color-200: mat.get-color-from-palette($warn-palette, 200);
  $warn-color-500: mat.get-color-from-palette($warn-palette, 500);
  $ok-color: palette.$ok-color;

  // text-color
  $text-color: mat.get-color-from-palette($foreground-palette, text);
  $background-color: mat.get-color-from-palette($background-palette, background);

  // text-contrast color to primary background
  $text-color-primary-contrast: mat.get-contrast-color-from-palette($primary-palette, 500); //'default' as property does NOT work - 500 should be default value

  $text-color-primary-50-contrast: mat.get-contrast-color-from-palette($primary-palette, 50);
  $text-color-primary-400-contrast: mat.get-contrast-color-from-palette($primary-palette, 400);


  // background colors
  // $background-color: mat.get-color-from-palette($background-palette, 'card');
  // @debug "$background-color: #{$background-color}";

  // components specific mixins
  // @include header.header-nav-link-color($primary-color, $text-color);
  // @include header.header-background-color($background-color);

  @include pass-hint.hint-colors($text-color, $warn-color, $ok-color);
  @include error-comp.error-colors($warn-color-200, $warn-color);

  // toolbar used on marketplace filter and org search
  @include toolbar.search-filter-color(if($is-dark-theme, $primary-color-500, $primary-color-50),
    if($is-dark-theme, $text-color-primary-contrast, $text-color-primary-50-contrast));

  @include hover.hover-color($primary-color, $text-color-primary-contrast);
}
